BasicThreatBar = LibStub("AceAddon-3.0"):NewAddon("BasicThreatBar", "AceConsole-3.0", "AceEvent-3.0")
local self = BasicThreatBar
local UPDATEPERIOD, elapsed = .25, 0

local LSM = LibStub("LibSharedMedia-3.0")

--Register some additional Blizzard bar textures
LSM:Register("statusbar", "Blizzard2", "Interface\\TARGETINGFRAME\\UI-TargetingFrame-Barfill")
LSM:Register("statusbar", "Blizzard3", "Interface\\RAIDFRAME\\Raid-Bar-Hp-Fill")
LSM:Register("statusbar", "Blizzard4", "Interface\\TARGETINGFRAME\\BarFill2")
LSM:Register("statusbar", "Blizzard5", "Interface\\RAIDFRAME\\Raid-Bar-Resource-Fill")
LSM:Register("statusbar", "Blizzard Archeology", "Interface\\Archeology\\Arch-Progress-Fill")
	


local threatbar = CreateFrame("StatusBar", "ThreatBar", UIParent)

threatbar:SetMovable(true)
threatbar:SetResizable(true)
threatbar:SetClampedToScreen( true )
threatbar:SetMaxResize(500,125);
threatbar:SetMinResize(125,10);
threatbar:RegisterForDrag("LeftButton");

local function GetPosition()
local point, _, relativePoint, xOfs, yOfs = threatbar:GetPoint()
	self.db.profile.point = point
	self.db.profile.relativePoint = relativePoint
	self.db.profile.xOfs = xOfs
	self.db.profile.yOfs = yOfs
end

threatbar:SetScript("OnDragStart", function(s) 
	if not UnitAffectingCombat("player") then
		s:StartMoving()
	end
end)
threatbar:SetScript("OnDragStop", function(s) 
s:StopMovingOrSizing()
GetPosition()
end)

threatbar:SetMinMaxValues(0, 100)
threatbar:SetValue(0)

-- border frame
local borderframe = CreateFrame("Frame", "BorderFrame", ThreatBar)
borderframe:SetPoint("TOPLEFT", ThreatBar, "TOPLEFT", -2, 2)
borderframe:SetPoint("BOTTOMRIGHT", ThreatBar, "BOTTOMRIGHT", 2, -2)



local function SetBorder()
borderframe:SetBackdrop( { 
  bgFile = "bgFile", 
  edgeFile = LSM:Fetch("border", self.db.profile.border), tile = 1, tileSize = 10, edgeSize = 10, 
  insets = { left = 0, right = 0, top = 0, bottom = 0 }
});
borderframe:SetBackdropBorderColor(self.db.profile.borderRed, self.db.profile.borderGreen, self.db.profile.borderBlue, self.db.profile.borderAlpha)
end



local font1 = threatbar:CreateFontString("UnitName", "OVERLAY", "GameFontWhite")

local function SetNamePoint()
	font1:ClearAllPoints()
	if self.db.profile.NamePoint == "BOTTOMLEFT" or self.db.profile.NamePoint == "BOTTOMRIGHT" or self.db.profile.NamePoint == "BOTTOM" then
		font1:SetPoint(self.db.profile.NamePoint, threatbar, self.db.profile.NamePoint, 0, -16)
	elseif self.db.profile.NamePoint == "LEFT" or self.db.profile.NamePoint == "RIGHT" or self.db.profile.NamePoint == "CENTER" then
		font1:SetPoint(self.db.profile.NamePoint, threatbar, self.db.profile.NamePoint, 0, 0)
	else
		font1:SetPoint(self.db.profile.NamePoint, threatbar, self.db.profile.NamePoint, 0, 16)
	end
end

local font2 = threatbar:CreateFontString("Percent", "OVERLAY", "GameFontWhite")

local function SetThreatPoint()
	font2:ClearAllPoints()
	if self.db.profile.ThreatPoint == "BOTTOMLEFT" or self.db.profile.ThreatPoint == "BOTTOMRIGHT" or self.db.profile.ThreatPoint == "BOTTOM" then
		font2:SetPoint(self.db.profile.ThreatPoint, threatbar, self.db.profile.ThreatPoint, 0, -16)
	elseif self.db.profile.ThreatPoint == "TOPLEFT" or self.db.profile.ThreatPoint == "TOPRIGHT" or self.db.profile.ThreatPoint == "TOP" then
		font2:SetPoint(self.db.profile.ThreatPoint, threatbar, self.db.profile.ThreatPoint, 0, 16)
	else
		font2:SetPoint(self.db.profile.ThreatPoint, threatbar, self.db.profile.ThreatPoint, 0, 0)
	end
end


--local icon = threatbar:CreateTexture("Icon", "OVERLAY")
--icon:SetTexture("Interface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES")
--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("TANK"))
--icon:SetPoint("TOPLEFT", threatbar, "TOPLEFT", 0, 15)
--icon:SetHeight(14)
--icon:SetWidth(14)
--icon:Hide()

local function SetFont()
local flags = {}
    if self.db.profile.outline then
        tinsert(flags, "OUTLINE")
    end
    if self.db.profile.monochrome then
        tinsert(flags, "MONOCHROME")
    end
    if self.db.profile.thickoutline then
        tinsert(flags, "THICKOUTLINE")
    end
font1:SetFont(LSM:Fetch("font", self.db.profile.font), self.db.profile.fontsize, table.concat(flags, ","))
font2:SetFont(LSM:Fetch("font", self.db.profile.font), self.db.profile.fontsize, table.concat(flags, ","))
end

local function SetTexture()
	threatbar:SetStatusBarTexture(LSM:Fetch("statusbar", self.db.profile.texture))
	threatbar:SetBackdrop({ 
	bgFile = LSM:Fetch("statusbar", self.db.profile.texture),
	insets = {left = 0, right = 0, top = 0, bottom = 0}
})
	threatbar:SetBackdropColor(0, 0, 0, .5)
end

function BasicThreatBar:RefreshConfig()
	threatbar:ClearAllPoints()
	threatbar:SetHeight(self.db.profile.height)
	threatbar:SetWidth(self.db.profile.width)
	threatbar:SetPoint(self.db.profile.point, UIParent, self.db.profile.relativePoint, self.db.profile.xOfs, self.db.profile.yOfs)
	SetTexture()
	SetFont()
	SetNamePoint()
	SetThreatPoint()
	SetBorder()
	font2:SetTextColor(self.db.profile.red, self.db.profile.green, self.db.profile.blue, self.db.profile.alpha)
		
	if not self.db.profile.hidden then
		threatbar:Show()
		threatbar:EnableMouse(true)
	else
		threatbar:Hide()
		threatbar:EnableMouse(false)
	end

end

local TextPosition = {
	["TOPLEFT"] = "Top Left",
	["TOP"] = "Top",
	["TOPRIGHT"] = "Top Right",
	["BOTTOMLEFT"] = "Bottom Left",
	["BOTTOMRIGHT"] = "Bottom Right",
	["BOTTOM"] = "Bottom",
	["LEFT"] = "Left Inside",
	["RIGHT"] = "Right Inside",
	["CENTER"] = "Center",
}

local defaults = {
  profile = {
    hidden = false, 
	font = "Friz Quadrata TT",
	texture = "Blizzard", 
	fontsize = 12, 
	point = "CENTER", 
	relativePoint = "CENTER", 
	xOfs = 0, 
	yOfs = 0, 
	height = 30, 
	width = 200, 
	outline = false, 
	monochrome = false, 
	thickoutline = false, 
	red = 1, 
	green = 1, 
	blue = 1, 
	alpha = 1,
	NamePoint = "TOP",
	ThreatPoint = "CENTER",
	border = "None",
	borderRed = 1,
	borderGreen = 1,
	borderBlue = 1,
	borderAlpha = 1,
  }
}

local options = {
    name = "BasicThreatBar",
    type = 'group',
	args = {
		general = {
			order = 1,
			name = "General",
			type = 'group',
			args = {
				Hide = {
				name = "Hide/Lock bar",
				desc = 'Hide the bar when not in combat and lock it in place',
				type = 'toggle',
				order = 1,
				set = function(info, key)
					self.db.profile.hidden = key
					if self.db.profile.hidden then
					threatbar:Hide()
					threatbar:EnableMouse(false)
					else
					threatbar:Show()
					threatbar:EnableMouse(true)
					end
				end,
				get = function(info)
					return self.db.profile.hidden
				end,
				},
		demo = {
			order = 2,
			type = 'execute',
			name = "Test",
			desc = "Display sample text and value on the threat bar.",
			func = function()
					font1:SetText("Sample")
					font2:SetText("50K | 75%")
					threatbar:SetValue(75)
					threatbar:SetStatusBarColor(.1, 1, .1, 1)
				end,
		},
		Border = {
		name = "Border",
		type = 'group',
		inline = true,
		order = 3,
		args = {
		Borders = {
            type = 'select',
            name = 'Borders',
            desc = 'Change the bars border',
			order = 1,
            set = function(info,key)
			self.db.profile.border = key -- saves our new selection to the current one
			SetBorder()
			end,
            get = function()
			return self.db.profile.border -- variable that is my current selection
			end,
			dialogControl = "LSM30_Border",
			values = LSM:HashTable("border"),
				},
		border_color = {
        		name = "Border Color",
        		desc = "Changes the color of the border",
        		type = "color",
				hasAlpha = true,
        		order = 2,
        		set = function(info, r, g, b ,a)
        		self.db.profile.borderRed, self.db.profile.borderGreen, self.db.profile.borderBlue, self.db.profile.borderAlpha = r, g, b, a
        		borderframe:SetBackdropBorderColor(self.db.profile.borderRed, self.db.profile.borderGreen, self.db.profile.borderBlue, self.db.profile.borderAlpha)
        		end,
                get = function(info)
                return self.db.profile.borderRed, self.db.profile.borderGreen, self.db.profile.borderBlue, self.db.profile.borderAlpha
                end,
        	},
		},
		},
		Text = {
		name = "Text",
		type = 'group',
		inline = true,
		order = 4,
		args = {
			Fonts = {
				type = 'select',
				name = 'Fonts',
				desc = 'Change the Font',
				order = 1,
				set = function(info,key)
				self.db.profile.font = key -- saves our new selection to the current one
				SetFont()
				end,
				get = function()
				return self.db.profile.font -- variable that is my current selection
				end,
				dialogControl = "LSM30_Font",
				values = LSM:HashTable("font"),
			},
			fontSize = {
				type = 'range',
				name = 'Font size',
				min = 8,
				max = 32,
				step = 1,
				order = 10,
				set = function(info,key)
				self.db.profile.fontsize = key -- saves our new selection to the current one
				SetFont()
				end,
				get = function()
				return self.db.profile.fontsize -- variable that is my current selection
				end,
			},
			font_outline = {
        		name = "Outline",
        		desc = "Adds outline to the font",
        		type = "toggle",
        		order = 120,
        		set = function(info, key)
					self.db.profile.outline = key
					SetFont()
        		end,
                get = function(info)
                return self.db.profile.outline
                end,
        	},
			font_monochrome = {
        		name = "Monochrome",
        		desc = "Adds monochrome to the font",
        		type = "toggle",
        		order = 100,
        		set = function(info, key)
        			self.db.profile.monochrome = key
					SetFont()
        		end,
                get = function(info)
                return self.db.profile.monochrome
                end,
        	},
        	font_thickoutline = {
        		name = "Thick Outline",
        		desc = "Adds a thick black outline to the font",
        		type = "toggle",
        		order = 110,
        		set = function(info, key)
        		self.db.profile.thickoutline = key
        		SetFont()
        		end,
                get = function(info)
                return self.db.profile.thickoutline
                end,
        	},
			font_color = {
        		name = "Color",
        		desc = "Changes the color of the threat text",
        		type = "color",
        		order = 90,
        		set = function(info, r, g, b ,a)
        		self.db.profile.red, self.db.profile.green, self.db.profile.blue, self.db.profile.alpha = r, g, b, a
        		font2:SetTextColor(self.db.profile.red, self.db.profile.green, self.db.profile.blue, self.db.profile.alpha)
        		end,
                get = function(info)
                return self.db.profile.red, self.db.profile.green, self.db.profile.blue, self.db.profile.alpha
                end,
        	},
			Name_Position = {
				type = 'select',
				name = 'Name Position',
				desc = 'Change the alignment of the name text',
				order = 130,
				set = function(info, key)
				self.db.profile.NamePoint = key -- saves our new selection to the current one
				SetNamePoint()
				end,
				get = function()
				return self.db.profile.NamePoint -- variable that is my current selection
				end,
				values = TextPosition,
			},
			Threat_Position = {
				type = 'select',
				name = 'Threat Position',
				desc = 'Change the alignment of the threat text',
				order = 140,
				set = function(info, key)
				self.db.profile.ThreatPoint = key -- saves our new selection to the current one
				SetThreatPoint()
				end,
				get = function()
				return self.db.profile.ThreatPoint -- variable that is my current selection
				end,
				values = TextPosition,
			},
		},
	},
	Bar = {
	name = "Bar",
    type = 'group',
	inline = true,
	order = 5,
    args = {
		Textures = {
            type = 'select',
            name = 'Textures',
            desc = 'Change the bar texture',
			order = 1,
            set = function(info,key)
			self.db.profile.texture = key -- saves our new selection to the current one
			SetTexture()
			end,
            get = function()
			return self.db.profile.texture -- variable that is my current selection
			end,
			dialogControl = "LSM30_Statusbar",
			values = LSM:HashTable("statusbar"),
				},
			Height = {
				type = 'range',
				name = 'Bar Height',
				min = 10,
				max = 125,
				step = 1,
				order = 2,
				set = function(info,key)
				self.db.profile.height = key -- saves our new selection to the current one
				threatbar:SetHeight(self.db.profile.height)
				end,
				get = function()
				return self.db.profile.height -- variable that is my current selection
				end,
			},
			Width = {
				type = 'range',
				name = 'Bar Width',
				min = 125,
				max = 500,
				step = 1,
				order = 3,
				set = function(info,key)
				self.db.profile.width = key -- saves our new selection to the current one
				threatbar:SetWidth(self.db.profile.width)
				end,
				get = function()
				return self.db.profile.width -- variable that is my current selection
				end,
			},
			
			},
		},
	},
		},
		},
}

function BasicThreatBar:OnInitialize()

	self.db = LibStub("AceDB-3.0"):New("BasicThreatBarDB", defaults)
	
	options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	local AceConfig = LibStub("AceConfig-3.0")
	AceConfig:RegisterOptionsTable("BasicThreatBar", options, nil)
	self.optionsFrame = {}
	local AceConfigDialog = LibStub("AceConfigDialog-3.0")
	self.optionsFrame.Main = AceConfigDialog:AddToBlizOptions("BasicThreatBar", "BasicThreatBar", nil, "general")
	
	AceConfigDialog:AddToBlizOptions(
	    "BasicThreatBar", options.args.profile.name, "BasicThreatBar", "profile")
	
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
	
end

function BasicThreatBar:OnEnable()
BasicThreatBar:RefreshConfig()
BasicThreatBar:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE")
BasicThreatBar:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
BasicThreatBar:RegisterEvent("PLAYER_TARGET_CHANGED")
BasicThreatBar:RegisterEvent("PARTY_MEMBERS_CHANGED")
BasicThreatBar:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
BasicThreatBar:RegisterEvent("UNIT_TARGET")
end

BasicThreatBar:RegisterChatCommand("btb", "Slashhandler")

function BasicThreatBar:Slashhandler(input)
	if (input=="show") then
		threatbar:Show()
		self.db.profile.hidden = nil
		threatbar:EnableMouse(true)
	elseif (input=="hide") then
		threatbar:Hide()
		self.db.profile.hidden = true
		threatbar:EnableMouse(false)
	elseif (input=="" or input =="help") then
		InterfaceOptionsFrame_OpenToCategory("BasicThreatBar")
	end
end

local function GetShortTV(v)
	if v < 1000 and v > -1000 then
		return floor(v)
	elseif v >= 1000000 then
		return format("%.1fM", v/1000000)
	elseif v >= 1000 or v <= -1000 then
		return format("%.1fK", v/1000)
	end
end

local fademiActive = fademiActive -- set values
local tempthreat = {}--tempthreat -- set values
local currenttarget = currenttarget -- set values

local function GetLastThreat(mobId)
local targetGUID = UnitGUID("target")
if UnitCanAttack("player", mobId) then
	tempthreat[UnitGUID(mobId)] = select(5, UnitDetailedThreatSituation("player", mobId))
	if targetGUID == UnitGUID(mobId) then
		currenttarget = tempthreat[UnitGUID(mobId)]
	end
end
end

local function StoreThreat()
	if GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0 then
		if GetNumRaidMembers() > 0 then
			for i = 1, GetNumRaidMembers() do
				GetLastThreat("raidtarget"..i)
				GetLastThreat("raidpettarget"..i)
				GetLastThreat("raidtargettarget"..i)
				GetLastThreat("raidpettargettarget"..i)
			end
		else
			for i = 1, GetNumPartyMembers() do
				GetLastThreat("partytarget"..i)
				GetLastThreat("partypettarget"..i)
				GetLastThreat("partytargettarget"..i)
				GetLastThreat("partypettargettarget"..i)
			end
		end

	end
	GetLastThreat("target")
	GetLastThreat("pettarget")
	GetLastThreat("targettarget")
	GetLastThreat("focus")
	GetLastThreat("focustarget")
	GetLastThreat("mouseover")
	GetLastThreat("mouseovertarget")

end

local function GetThreat(unitId, mobId)
	local _, _, threatpct, _, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not threatpct then threatpct = 0 end
	return floor(threatpct)
end

local function GetThreatStatus(unitId, mobId)
	local _,status,_,_, _ = UnitDetailedThreatSituation(unitId, mobId)
	return status
end

local function GetTank(unitId, mobId)
	local isTanking,_,_,_, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not isTanking then isTanking = 0 end
	return isTanking
end

local function GetThreatValue(unitId, mobId)
	local _, _, _, _, threatvalue = UnitDetailedThreatSituation(unitId, mobId)
	local areaid = GetCurrentMapAreaID()
	if not threatvalue then threatvalue = 0 end
	if areaid == 824 then threatvalue = threatvalue * 10 end --Dragon Soul
	return threatvalue
end

local function GetClassColor(unit)
	local unitClass, englishClass = UnitClass(unit)
	local classColor = RAID_CLASS_COLORS[englishClass] 
	if not classColor then 
		classColor = {r = .5, g = .5, b = .5}
	end -- in case returns nil?
	return classColor.r, classColor.g, classColor.b
end

local function UpdateDisplay()
	font1:SetText("")
	font2:SetText("")
	--icon:Hide()
	threatbar:SetValue(0)
	threatbar:SetBackdropColor(0, 0, 0, .5)
	local status = nil
	local highUnit = nil
	local unitThreat = 0
	local highThreat = 0
	local tankName = nil
	local unitThreatValue = 0
	local playerThreatValue = 0
	local partynum = GetNumPartyMembers()
	local raidnum = GetNumRaidMembers()
	
	if self.db.profile.hidden == true  and not status then -- hide frame
		threatbar:Hide()
	end
	if (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "target") and not(UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) then --Solo Target			
		status = GetThreatStatus("player", "target")
		threatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		if HasPetUI() then
			unitThreatValue = GetThreatValue("pet", "target")
			highThreat = GetThreat("pet", "target")
			highUnit = UnitName("pet")
			highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("pet")
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) then --Solo Target of Target
		status = GetThreatStatus("player", "targettarget")
		threatpct = GetThreat("player", "targettarget")
		playerThreatValue = GetThreatValue("player", "targettarget")
		if HasPetUI() then
			unitThreatValue = GetThreatValue("pet", "targettarget")
			highThreat = GetThreat("pet", "targettarget")
			highUnit = UnitName("pet")
			highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("pet")
			unitTanking = GetTank("pet", "targettarget")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) then --Raid Target 
		status = GetThreatStatus("player", "target")
		threatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "target") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raid"..i)
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("raid"..i)
					unitThreatValue = GetThreatValue("raid"..i, "target")
				end
			unitThreat = GetThreat("raidpet"..i, "target")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raidpet"..i)
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("pet")
					unitThreatValue = GetThreatValue("raidpet"..i, "target")
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "target")
				end
			unitTanking = GetTank("raid"..i, "target")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("raid"..i)
				tankName = UnitName("raid"..i)
			end
			unitTanking = GetTank("raidpet"..i, "target")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("raidpet"..i)
				tankName = UnitName("raidpet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) then --Raid Target of Target
		status = GetThreatStatus("player", "targettarget")
		threatpct = GetThreat("player", "targettarget")	
		playerThreatValue = GetThreatValue("player", "targettarget")
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "targettarget") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raid"..i)
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("raid"..i)
					unitThreatValue = GetThreatValue("raid"..i, "targettarget")
				end
			unitThreat = GetThreat("raidpet"..i, "targettarget")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raidpet"..i)
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("pet")
					unitThreatValue = GetThreatValue("raidpet"..i, "targettarget")
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "targettarget")
				end
			unitTanking = GetTank("raid"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("raid"..i)
				tankName = UnitName("raid"..i)
			end
			unitTanking = GetTank("raidpet"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("raidpet"..i)
				tankName = UnitName("raidpet"..i)
			end
			unitTanking = GetTank("pet", "targettarget")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) then -- Party Target 
		status = GetThreatStatus("player", "target")
		threatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "target") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("party"..i)
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("party"..i)
					unitThreatValue = GetThreatValue("party"..i, "target")
				end
			unitThreat = GetThreat("partypet"..i, "target")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("partypet"..i)
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("partypet"..i)
					unitThreatValue = GetThreatValue("partypet"..i, "target")
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "target")
				end
			unitTanking = GetTank("party"..i, "target")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("party"..i)
				tankName = UnitName("party"..i)
			end
			unitTanking = GetTank("partypet"..i, "target")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("partypet"..i)
				tankName = UnitName("partypet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) then --Party Target of Target
		status = GetThreatStatus("player", "targettarget")
		threatpct = GetThreat("player", "targettarget")
		playerThreatValue = GetThreatValue("player", "targettarget")
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "targettarget") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("party"..i)
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("party"..i)
					unitThreatValue = GetThreatValue("party"..i, "targettarget")
				end
			unitThreat = GetThreat("partypet"..i, "targettarget")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("partypet"..i)
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("partypet"..i)
					unitThreatValue = GetThreatValue("partypet"..i, "targettarget")
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColorR, highUnitColorG, highUnitColorB = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "targettarget")
				end
			unitTanking = GetTank("party"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("party"..i)
				tankName = UnitName("party"..i)
			end
			unitTanking = GetTank("partypet"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("partypet"..i)
				tankName = UnitName("partypet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColorR, unitTankingColorG, unitTankingColorB = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	end
	if status then -- show frame
		
		if self.db.profile.hidden == true and not threatbar:IsShown() then
			threatbar:Show()
		end
	end
	if status == 0 then
		--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("DAMAGER"))
		font2:SetText(string.format("%d %%", threatpct ))
		threatbar:SetValue(threatpct)
		threatbar:SetStatusBarColor(.1, 1, .1, 1)
		
		if tankName then
			--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("TANK"))
			--icon:Show()
			threatValuediff = ((unitThreatValue - playerThreatValue) / 100 )
			font1:SetText(tankName)
			font1:SetTextColor(unitTankingColorR, unitTankingColorG, unitTankingColorB, 1)
			--BasicThreatBar:Print(unitTankingColorR, unitTankingColorG, unitTankingColorB) --debug message
			font2:SetText(string.format("%s | %d %%", GetShortTV(threatValuediff), threatpct ))
			threatbar:SetValue(threatpct)
			if currenttarget then -- display temporary threat bar
				threatValuediff = ((unitThreatValue - currenttarget) / 100 )
				tempthreatpct = floor((currenttarget / unitThreatValue) * 100)
				font1:SetText(tankName)
				font1:SetTextColor(unitTankingColorR, unitTankingColorG, unitTankingColorB, 1)
				font2:SetText(string.format("%s | %d %%", GetShortTV(threatValuediff), tempthreatpct ))
				threatbar:SetValue(tempthreatpct)
				threatbar:SetStatusBarColor(.5, .5, 1, 1)
			end
		end
	elseif status == 1 then
		--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("DAMAGER"))
		font2:SetText(string.format("%d %%", threatpct ))
		threatbar:SetValue(threatpct)
		threatbar:SetStatusBarColor(1, 1, 0, 1)
		
		if tankName then
			--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("TANK"))
			--icon:Show()
			threatValuediff = ((unitThreatValue - playerThreatValue) / 100 )
			font1:SetText(tankName)
			font1:SetTextColor(unitTankingColorR, unitTankingColorG, unitTankingColorB, 1)
			--BasicThreatBar:Print(unitTankingColorR, unitTankingColorG, unitTankingColorB) --debug message
			font2:SetText(string.format("%s | %d %%", GetShortTV(threatValuediff), threatpct ))
			threatbar:SetValue(threatpct)
			if currenttarget then -- display temporary threat bar
				threatValuediff = ((unitThreatValue - currenttarget) / 100 )
				tempthreatpct = floor((currenttarget / unitThreatValue) * 100)
				font1:SetText(tankName)
				font1:SetTextColor(unitTankingColorR, unitTankingColorG, unitTankingColorB, 1)
				font2:SetText(string.format("%s | %d %%", GetShortTV(threatValuediff), tempthreatpct ))
				threatbar:SetValue(tempthreatpct)
				threatbar:SetStatusBarColor(.5, .5, 1, 1)
			end
		end
	elseif status == 2 then
		--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("DAMAGER"))
		font2:SetText("WEAK AGGRO!")
		threatbar:SetValue(threatpct)
		threatbar:SetStatusBarColor(1, .5, .25, 1)
		
		if highUnit then
			--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("DAMAGER"))
			--icon:Show()
			threatValuediff = ((playerThreatValue - unitThreatValue) / 100 )
			threatdiff = (threatpct - highThreat)
			font1:SetText(highUnit)
			font1:SetTextColor(highUnitColorR, highUnitColorG, highUnitColorB, 1)
			font2:SetText(string.format("%s | %s %%", GetShortTV(threatValuediff), threatdiff ))
			threatbar:SetValue(threatdiff)
			threatbar:SetBackdropColor(1, .5, .25, .5)
			if currenttarget then -- display temporary threat bar
				threatValuediff = ((unitThreatValue - currenttarget) / 100 )
				threatdiff = floor((currenttarget / unitThreatValue) * 100) - highThreat
				font1:SetText(highUnit)
				font1:SetTextColor(highUnitColorR, highUnitColorG, highUnitColorB, 1)
				font2:SetText(string.format("%s | %d %%", GetShortTV(threatValuediff), threatdiff ))
				threatbar:SetValue(threatdiff)
				threatbar:SetStatusBarColor(.5, .5, 1, 1)
			end
		end	
	elseif status == 3 then
		--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("DAMAGER"))
		font2:SetText("AGGRO!")
		threatbar:SetValue(threatpct)
		threatbar:SetStatusBarColor(1, .1, .1, 1)
		
		if highUnit then
			--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("DAMAGER"))
			--icon:Show()
			threatValuediff = ((playerThreatValue - unitThreatValue) / 100 )
			threatdiff = (threatpct - highThreat)
			font1:SetText(highUnit)
			font1:SetTextColor(highUnitColorR, highUnitColorG, highUnitColorB, 1)
			font2:SetText(string.format("%s | %s %%", GetShortTV(threatValuediff), threatdiff ))
			threatbar:SetValue(threatdiff)
			threatbar:SetBackdropColor(1, .1, .1, .5)
			if currenttarget then -- display temporary threat bar
				threatValuediff = ((unitThreatValue - currenttarget) / 100 )
				threatdiff = floor((currenttarget / unitThreatValue) * 100) - highThreat
				font1:SetText(highUnit)
				font1:SetTextColor(highUnitColorR, highUnitColorG, highUnitColorB, 1)
				font2:SetText(string.format("%s | %d %%", GetShortTV(threatValuediff), threatdiff ))
				threatbar:SetValue(threatdiff)
				threatbar:SetStatusBarColor(.5, .5, 1, 1)
			end
		end
	end
end
		
function BasicThreatBar:COMBAT_LOG_EVENT_UNFILTERED(event, ...)
		local timestamp, eventtype, hideCaster, srcGUID, srcName, srcFlags, srcFlags2, dstGUID, dstName, dstFlags, dstFlags2 = ...
		local targetGUID = UnitGUID("target")
		local damage
		local playerGUID = UnitGUID("player")
		if srcGUID == playerGUID then
		if eventtype == "SPELL_AURA_APPLIED" then
			local spellID = select(12, ...)
			if spellID == 55342 or spellID == 586 --[[or spellID == 1038]] then
				--DEFAULT_CHAT_FRAME:AddMessage("Temp spell casted") --debug message
				fademiActive = true
				StoreThreat()		-- set temp threat to last known threat value
			elseif spellID == 32612 and fademiActive == true then -- Invisibility buff while Mirror Image is active
				wipe(tempthreat)
			end
		elseif eventtype == "SPELL_DAMAGE" or eventtype == "RANGE_DAMAGE" or eventtype == "SPELL_PERIODIC_DAMAGE" then
			if fademiActive == true then
			--DEFAULT_CHAT_FRAME:AddMessage("Detecting damage") --debug message
			damage = select(15, ...)
			
			end
		elseif eventtype == "SWING_DAMAGE" then
			if fademiActive == true then
			damage = select(12, ...)
			
			end
		elseif eventtype == "SPELL_AURA_REMOVED" then
			local spellID = select(12, ...)
			if spellID == 55342 or spellID == 586 --[[or spellID == 1038]] then
				--DEFAULT_CHAT_FRAME:AddMessage("Temp spell expired") --debug message
				wipe(tempthreat) -- clear table
				damage = nil
				fademiActive = nil
				currenttarget = nil
			end	
		end
		if damage then
			tempthreat[dstGUID] = (tempthreat[dstGUID] or 0) + damage * 100
			if targetGUID == dstGUID then
				currenttarget = tempthreat[dstGUID]
			end
		end
		end
		
end
	
function BasicThreatBar:PLAYER_TARGET_CHANGED(event)
		local targetGUID = UnitGUID("target")
		if fademiActive == true then
			local intable = tContains(tempthreat, targetGUID)
			if not intable then
				currenttarget = nil
				--DEFAULT_CHAT_FRAME:AddMessage("currentarget set to nil") -- debug message
			end
			for index,value in pairs(tempthreat) do 
				if targetGUID == index then
					currenttarget = value
					--DEFAULT_CHAT_FRAME:AddMessage(tostring(index).." : "..tostring(value)) -- debug message
				
				end
			
			end

		UpdateDisplay()
	else
		UpdateDisplay()
	end
	
end

function BasicThreatBar:UNIT_THREAT_SITUATION_UPDATE(event, unitId)
	UpdateDisplay()
end

function BasicThreatBar:UNIT_THREAT_LIST_UPDATE(event, mobId)
	UpdateDisplay()
end

function BasicThreatBar:PARTY_MEMBERS_CHANGED(event)
	UpdateDisplay()
end

function BasicThreatBar:UNIT_TARGET(event, unitId)
	if UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) then
		threatbar:SetScript("OnUpdate", function(self, elap)
		elapsed = elapsed + elap
		if elapsed < UPDATEPERIOD then return end

		elapsed = 0
		UpdateDisplay()
		end)
	else
		threatbar:SetScript("OnUpdate", nil)
	end
end